


#include <pic18f27k42.h>

#include "RTC_DS3231_2021-03.h"
#include "mcc_generated_files/examples/i2c1_master_example.h"
///#define DS3231_ADDR 0xD0  //0x68 I2C Hardware : sur 7 bits sinon  0xD0 sur 8 bitsRTC_DS3231_2021-03.inc

 extern char tmp[]; 
 extern char CRam1[80];
 extern char Buffer1[];
 volatile uint16_t Index1;
 extern volatile int i1 ;
 extern char *p1;
 //extern i2c1_address_t Addr;
   
extern uint8_t Dec2Bcd(uint8_t n);    
extern  uint8_t Bcd2Dec( uint8_t  val);
extern  void BCD_To_Ascii(unsigned char cc,unsigned char * px);
extern void Print (char *t);
extern void CPrint (const char *t);
extern void putch(unsigned char c);
extern void CRLF1(void);

 

 
/*
void Display_Date_Time(char Visu);  // 12-06-2018
void Ds3231_Temp_CP(char mode) ;
void DS3231_Read_All_Registers(void);
unsigned char Lecture_Affichage_Registre_DS3231(char n, char imprime);
void I2C1_Write(unsigned char addr8, unsigned char addr_data, unsigned char* b, signed char n);
void MAJ_RTC(void);
    */
int My_AsciiToInteger(char * s)
{
	uint8_t	a;
	uint8_t	sign;

	while(*s == ' ' || *s == '\t')
		s++;
	a = 0;
	sign = 0;
	if(*s == '-') {
		sign++;
		s++;
	} else if(*s == '+')
		s++;
	while((*(s)>='0') && (*(s)<='9'))  ///    isdigit(*s))
		a = a*10 + (*s++ - '0');
	if(sign)
		return -a;
	return a;
}




 void DS3231_Read_All_Registers()
 {  int i;
     //Lecture des 7 registre RTC DS3231
   // RAZ table d'echange
    for (i=0;i<10;i++) tmp[i]=0 ;
    p1=&tmp[0]; // pointeur sur debut de table
    I2C1_ReadDataBlock(DS3231_ADDR,0,p1,7); 
   // SQA=0;
     second=tmp[0];
     minute=tmp[1];
     heure=tmp[2]&0x3F;
     jS=tmp[3];
     if (jS>7) jS=0;
     jour=tmp[4];
     mois=tmp[5]& 0x1F;
     Annee=tmp[6];
     tmp[7]=0;
     tmp[8]=0;
    }

char Lecture_Affichage_Registre_DS3231(char n, char Imprime)
{
   static char Reponse;
  // DS3231_Read_All_Registers
   Reponse=I2C1_Read1ByteRegister(DS3231_ADDR,n);
        //  SQA=0;
    //   Reponse=tmp[0];  // recupre la valeur Minute de la RTC
     if (Imprime==1)
       { 
        BCD_To_Ascii(Reponse,CRam1);
        Print(CRam1); 
        putch(9);
        }
       return Reponse;
  }
  
  

void Ds3231_Temp_CP(char mode)
  {
   // " range: -99 to +127 degree
   unsigned char msb, lsb, tmp1;
    // read the two temperature registers:
    msb=Lecture_Affichage_Registre_DS3231(0x11,0);
    lsb=Lecture_Affichage_Registre_DS3231(0x12,0);

   tmp1 = ' ';
   if (msb & 0x80)
   { // SIGN_bit = 1: negative
      tmp1 = '-';
      // two's complement conversion:
      msb ^= 0xFF;
      if (!lsb)
         ++msb; // required if the fractional portion is zero
      else
         lsb=lsb | 0x01 ; // negative fract. sign, normally it is 0
   }
   else
   {
   if (msb > 99)
   {
      msb -= 100;
      tmp1 = '1';
   }
   }
   // the first char is a space, '-' or '1':
   DS_Temp[0]=tmp1;
   //Lcd_Chr_CP(tmp);
   // convert msb (binary value) to 2 ASCII digits
   for ( tmp1 = '0' ; msb > 9 ; ++tmp1, msb -= 10 );
   // display integer portion:
   DS_Temp[1]=tmp1;
   DS_Temp[2]=msb+'0';
   // decimal point:
   DS_Temp[3]= '.';
   // compute fract. part:
   msb = '0';
   tmp1 = '0';
   if (lsb)
   {
      // positive 7,6 bits: 01(25), 10(50), 11(75)
      // negative 7,6 bits: 01(75), 10(50), 11(25)
     // if (!lsb.B6)
      if (( lsb & 64)==0)    
         msb = '5'; // 50
      else
      {
         msb = '2';
         tmp1 = '5';
       //  if (lsb.B0) // negative fract. (see above): 25 <> 75
       //     lsb.B7 = !lsb.B7;
       //  if (lsb.B7)
       //     msb = '7';
         if (lsb & 0x01) // negative fract. (see above): 25 <> 75
            lsb=lsb & 0x7F;
         if (lsb & 0x80)
            msb = '7'; 
           
         
      }
   } // fract. part

   DS_Temp[4]= msb;
   DS_Temp[5]= tmp1;
  if (mode==0)  DS_Temp[6]=''; else DS_Temp[6]= 176;  // for LCD
   DS_Temp[7]= 'C';
   DS_Temp[8]=0;
} // end of Ds3231_Temp_CP()


void Display_Date_Time(char Visu)
{   char Adresse,Registre;
  //  signed char Nb;
    int i;
    Registre=0;
    //Nb=7;
   // for(i=0;i<8;i++) tmp[i]=0;
   // p1=&tmp[0];
    DS3231_Read_All_Registers();
    time[0]=0;
    date[0]=0;
     BCD_To_Ascii(heure,time) ;   time[2]='H';
     BCD_To_Ascii(minute,time+3 );  time[5]='M';
     BCD_To_Ascii(second,time+6);   time[8]='S';time[9]=0;
     BCD_To_Ascii(jour,date); date[2]='/';
     BCD_To_Ascii(mois,date+3); date[5]='/';
     BCD_To_Ascii(Annee,date+6); date[8]=0;
     Month=Bcd2Dec(mois);
     Sec= Bcd2Dec(second);
   if( Visu==1)
   {   Print(date);  CPrint(Blancs);
       Print(time); CPrint(Blancs);
    }
  }


 void Print_Date_Complete(void)
 {
     DS3231_Read_All_Registers();
     time[0]=0;
     BCD_To_Ascii(jour,date); date[2]='/';
     BCD_To_Ascii(mois,date+3); date[5]='/';
     BCD_To_Ascii(Annee,date+6); date[8]=0;
     
     CPrint(JourSemaine[jS]);putch(' ');
     BCD_To_Ascii(jour,CRam1);Print (CRam1);putch(' ');
     Month=Bcd2Dec(mois);
     CPrint(Douze_Mois[Month]);putch(' ');
     BCD_To_Ascii(Annee,CRam1);Print (CRam1);putch(' ');
   
     BCD_To_Ascii(heure,time) ;   time[2]='H';
     BCD_To_Ascii(minute,time+3 );  time[5]='M';
     BCD_To_Ascii(second,time+6);   time[8]='S';time[9]=0;
     Print(time);
     CRLF1();
  }

  
  
void MAJ_RTC(void)
{ 
   
    int m,i,j,k;
  m=2; // passe par dessus "U;"
  // U;24;08;17;17;36;02#
  j=0;
  //Status=0;
  // Print(Buffer1);CRLF1();
  *(Buffer1+Index1)=0;
   if ((Index1<22)&&(Index1>18))
    {
       // CPrint(" Index1 = ");
       // WordToStr(Index1,CRam1);
       //  Print(CRam1);
       // CRLF1();
        for (i=2;i<Index1;i++)
        {
          if(Buffer1[i]==';')
              {
                Buffer1[i]=0;
               DateTime[j]=My_AsciiToInteger(Buffer1+m);
            //  Print(Buffer1+m); putch(';');
               j++;
               m=i+1;
              }
       }// for i
        DateTime[j]=My_AsciiToInteger(Buffer1+m);
     //   CRLF1();
        jour=DateTime[0];
        mois=DateTime[1] & 0x1F;
        Annee=DateTime[2];
        heure=DateTime[3];
        minute=DateTime[4];
        jS=DateTime[5] & 0x07; // jour de la semaine
       // CPrint("\r\n Jour Semaine jS =");
       // ByteToStr(jS,CRam1);
       // Print(CRam1);
      //  Envoi_Char(9);
      //  CPrint(JourSemaine[jS]); Envoi_Char(9);
      //  CPrint(" mois =");
        Month=Bcd2Dec(mois);
        if (Month>12) Month=0;
      //  CPrint( Douze_Mois[Month]);
      //  CRLF1();

        if (jS>7)
        {
             jS=0;  // error si defaut !
              CPrint("\r\nErreur sur Jour Semaine jS. \r\n");
        }
       // CPrint("\r\n param Ok\r\n");
        tmp[0]=0x00;  //start register
        second=0;
        tmp[1]=second; //Reset second to 0 sec. and stop Oscillator
        tmp[2]=Dec2Bcd(minute); //write min
        tmp[3]=Dec2Bcd(heure); //write hour
        tmp[4]=jS; //write day of week
        tmp[5]=Dec2Bcd(jour); // write date
        tmp[6]=Dec2Bcd(mois); // write month
        tmp[7]=Dec2Bcd(Annee); // write year
        tmp[8]=0x00;
        p1=&tmp[0];
        I2C1_WriteNBytes(DS3231_ADDR,p1,8);
        // __delay_ms(10);
        // set SQW output  Start oscillateur
        //tmp[0]=0x40; // data 
        //I2C1_Write1ByteRegister(DS3231_ADDR,0x0E, tmp[0]);
        CPrint("Ecriture DS3231... OK\r\n");
    }
    else
    {
    CPrint("\r\n Rappel format de cde : \"U;JJ;MM;AA;HH;MM;jS;#\" \r\n");
    CPrint(" U;24;08;17;18;36;04#  pour 24 Aout 2017  18H36 04=Jeudi\r\n\r\n");
    }
 
 }

    